# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class IaasapimachinesBootConfigSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'phone_home_should_wait': 'bool',
        'phone_home_timeout_seconds': 'int',
        'phone_home_fail_on_timeout': 'bool',
        'deployment_fail_on_cloud_config_runtime_error': 'bool'
    }

    attribute_map = {
        'phone_home_should_wait': 'phoneHomeShouldWait',
        'phone_home_timeout_seconds': 'phoneHomeTimeoutSeconds',
        'phone_home_fail_on_timeout': 'phoneHomeFailOnTimeout',
        'deployment_fail_on_cloud_config_runtime_error': 'deploymentFailOnCloudConfigRuntimeError'
    }

    def __init__(self, phone_home_should_wait=None, phone_home_timeout_seconds=None, phone_home_fail_on_timeout=None, deployment_fail_on_cloud_config_runtime_error=None):  # noqa: E501
        """IaasapimachinesBootConfigSettings - a model defined in Swagger"""  # noqa: E501
        self._phone_home_should_wait = None
        self._phone_home_timeout_seconds = None
        self._phone_home_fail_on_timeout = None
        self._deployment_fail_on_cloud_config_runtime_error = None
        self.discriminator = None
        if phone_home_should_wait is not None:
            self.phone_home_should_wait = phone_home_should_wait
        if phone_home_timeout_seconds is not None:
            self.phone_home_timeout_seconds = phone_home_timeout_seconds
        if phone_home_fail_on_timeout is not None:
            self.phone_home_fail_on_timeout = phone_home_fail_on_timeout
        if deployment_fail_on_cloud_config_runtime_error is not None:
            self.deployment_fail_on_cloud_config_runtime_error = deployment_fail_on_cloud_config_runtime_error

    @property
    def phone_home_should_wait(self):
        """Gets the phone_home_should_wait of this IaasapimachinesBootConfigSettings.  # noqa: E501

        A phone_home module will be added to the Cloud Config and the provisioning will wait on a callback prior proceeding  # noqa: E501

        :return: The phone_home_should_wait of this IaasapimachinesBootConfigSettings.  # noqa: E501
        :rtype: bool
        """
        return self._phone_home_should_wait

    @phone_home_should_wait.setter
    def phone_home_should_wait(self, phone_home_should_wait):
        """Sets the phone_home_should_wait of this IaasapimachinesBootConfigSettings.

        A phone_home module will be added to the Cloud Config and the provisioning will wait on a callback prior proceeding  # noqa: E501

        :param phone_home_should_wait: The phone_home_should_wait of this IaasapimachinesBootConfigSettings.  # noqa: E501
        :type: bool
        """

        self._phone_home_should_wait = phone_home_should_wait

    @property
    def phone_home_timeout_seconds(self):
        """Gets the phone_home_timeout_seconds of this IaasapimachinesBootConfigSettings.  # noqa: E501

        The period of time to wait for the phone_home module callback to occur  # noqa: E501

        :return: The phone_home_timeout_seconds of this IaasapimachinesBootConfigSettings.  # noqa: E501
        :rtype: int
        """
        return self._phone_home_timeout_seconds

    @phone_home_timeout_seconds.setter
    def phone_home_timeout_seconds(self, phone_home_timeout_seconds):
        """Sets the phone_home_timeout_seconds of this IaasapimachinesBootConfigSettings.

        The period of time to wait for the phone_home module callback to occur  # noqa: E501

        :param phone_home_timeout_seconds: The phone_home_timeout_seconds of this IaasapimachinesBootConfigSettings.  # noqa: E501
        :type: int
        """

        self._phone_home_timeout_seconds = phone_home_timeout_seconds

    @property
    def phone_home_fail_on_timeout(self):
        """Gets the phone_home_fail_on_timeout of this IaasapimachinesBootConfigSettings.  # noqa: E501

        In case a timeout occurs whether the provisioning process should fail or continue.  # noqa: E501

        :return: The phone_home_fail_on_timeout of this IaasapimachinesBootConfigSettings.  # noqa: E501
        :rtype: bool
        """
        return self._phone_home_fail_on_timeout

    @phone_home_fail_on_timeout.setter
    def phone_home_fail_on_timeout(self, phone_home_fail_on_timeout):
        """Sets the phone_home_fail_on_timeout of this IaasapimachinesBootConfigSettings.

        In case a timeout occurs whether the provisioning process should fail or continue.  # noqa: E501

        :param phone_home_fail_on_timeout: The phone_home_fail_on_timeout of this IaasapimachinesBootConfigSettings.  # noqa: E501
        :type: bool
        """

        self._phone_home_fail_on_timeout = phone_home_fail_on_timeout

    @property
    def deployment_fail_on_cloud_config_runtime_error(self):
        """Gets the deployment_fail_on_cloud_config_runtime_error of this IaasapimachinesBootConfigSettings.  # noqa: E501

        In case an error is thrown while processing cloud-config whether the provisioning process should fail or continue.  # noqa: E501

        :return: The deployment_fail_on_cloud_config_runtime_error of this IaasapimachinesBootConfigSettings.  # noqa: E501
        :rtype: bool
        """
        return self._deployment_fail_on_cloud_config_runtime_error

    @deployment_fail_on_cloud_config_runtime_error.setter
    def deployment_fail_on_cloud_config_runtime_error(self, deployment_fail_on_cloud_config_runtime_error):
        """Sets the deployment_fail_on_cloud_config_runtime_error of this IaasapimachinesBootConfigSettings.

        In case an error is thrown while processing cloud-config whether the provisioning process should fail or continue.  # noqa: E501

        :param deployment_fail_on_cloud_config_runtime_error: The deployment_fail_on_cloud_config_runtime_error of this IaasapimachinesBootConfigSettings.  # noqa: E501
        :type: bool
        """

        self._deployment_fail_on_cloud_config_runtime_error = deployment_fail_on_cloud_config_runtime_error

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IaasapimachinesBootConfigSettings, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IaasapimachinesBootConfigSettings):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
